/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.3 Revision 1.84
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.3 2005/08/07 14:15:10 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.84 2012/03/18 23:33:49 hd_brummy Exp $
4
5# @ECLASS: vdr-plugin.eclass
6# @MAINTAINER:
7# vdr@gentoo.org
8# @BLURB: common vdr plugin ebuild functions
9# @DESCRIPTION:
10# Eclass for easing maitenance of vdr plugin ebuilds
11
12# Authors:
13# Matthias Schwarzott <zzam@gentoo.org>
14# Joerg Bornkessel <hd_brummy@gentoo.org>
15# Christian Ruppert <idl0r@gentoo.org>
16
17# Plugin config file installation:
4# 18#
5# Author: 19# A plugin config file can be specified through the $VDR_CONFD_FILE variable, it
6# Matthias Schwarzott <zzam@gentoo.org> 20# defaults to ${FILESDIR}/confd. Each config file will be installed as e.g.
21# ${D}/etc/conf.d/vdr.${VDRPLUGIN}
7 22
8# vdr-plugin.eclass 23# Installation of rc-addon files:
24# NOTE: rc-addon files must be valid shell scripts!
9# 25#
10# eclass to create ebuilds for vdr plugins 26# Installing rc-addon files is basically the same as for plugin config files
27# (see above), it's just using the $VDR_RCADDON_FILE variable instead.
28# The default value when $VDR_RCADDON_FILE is undefined is:
29# ${FILESDIR}/rc-addon.sh and will be installed as
30# ${VDR_RC_DIR}/plugin-${VDRPLUGIN}.sh
11# 31#
32# The rc-addon files will be sourced by the startscript when the specific plugin
33# has been enabled.
34# rc-addon files may be used to prepare everything that is necessary for the
35# plugin start/stop, like passing extra command line options and so on.
12 36
13# Example ebuild (vdr-femon): 37# Applying your own local/user patches:
38# This is done by using the epatch_user() function of the eutils.eclass.
39# Simply put your patches into one of these directories:
40# /etc/portage/patches/<CATEGORY>/<PF|P|PN>/
41# Quote: where the first of these three directories to exist will be the one to
42# use, ignoring any more general directories which might exist as well.
14# 43#
15# inherit vdr-plugin 44# For more details about it please take a look at the eutils.class.
45
46inherit base multilib eutils flag-o-matic
47
48if ! has "${EAPI:-0}" 0 1 2 3 4; then
49 die "API of vdr-plugin.eclass in EAPI=\"${EAPI}\" not established"
50fi
51
16# IUSE="" 52IUSE=""
17# SLOT="0"
18# DESCRIPTION="vdr Plugin: DVB Frontend Status Monitor (signal strengt/noise)"
19# HOMEPAGE="http://www.saunalahti.fi/~rahrenbe/vdr/femon/"
20# SRC_URI="http://www.saunalahti.fi/~rahrenbe/vdr/femon/files/${P}.tgz"
21# LICENSE="GPL-2"
22# KEYWORDS="~x86"
23# DEPEND=">=media-video/vdr-1.3.27"
24#
25#
26
27# There are some special files in ${FILESDIR} which get installed when
28# they exist:
29
30# ${FILESDIR}/confd-${PV} or ${FILESDIR}/confd:
31# The first matching is installed under /etc/conf.d/vdr.${VDRPLUGIN}
32# (in example vdr-femon this would be /etc/conf.d/vdr.femon)
33#
34# Everything put in variable _EXTRAOPTS is appended to the command line of
35# the plugin.
36
37
38# ${FILESDIR}/rc-addon-${PV}.sh or ${FILESDIR}/rc-addon.sh:
39# The first matching is installed under /usr/lib/vdr/rcscript/vdr.${VDRPLUGIN}.sh
40# (in example vdr-femon this would be /usr/lib/vdr/rcscript/vdr.femon.sh)
41#
42# This file is sourced by the startscript when plugin is activated in /etc/conf.d/vdr
43# It could be used for special startup actions for this plugins, or to create the
44# plugin command line options from a nicer version of a conf.d file.
45
46inherit eutils flag-o-matic
47 53
48# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes 54# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes
49VDRPLUGIN="${PN/#vdrplugin-/}" 55VDRPLUGIN="${PN/#vdrplugin-/}"
50VDRPLUGIN="${VDRPLUGIN/#vdr-/}" 56VDRPLUGIN="${VDRPLUGIN/#vdr-/}"
51VDRPLUGIN="${VDRPLUGIN/%-cvs/}" 57VDRPLUGIN="${VDRPLUGIN/%-cvs/}"
54 60
55# works in most cases 61# works in most cases
56S="${WORKDIR}/${VDRPLUGIN}-${PV}" 62S="${WORKDIR}/${VDRPLUGIN}-${PV}"
57 63
58# depend on headers for DVB-driver 64# depend on headers for DVB-driver
59RDEPEND="" 65COMMON_DEPEND=">=media-tv/gentoo-vdr-scripts-0.4.2"
60DEPEND="|| (
61 >=sys-kernel/linux-headers-2.6.11-r2
62 media-tv/linuxtv-dvb
63 )"
64 66
65# Where should the plugins live in the filesystem 67DEPEND="${COMMON_DEPEND}
66VDR_PLUGIN_DIR="/usr/lib/vdr/plugins" 68 virtual/linuxtv-dvb-headers"
69RDEPEND="${COMMON_DEPEND}
70 >=app-admin/eselect-vdr-0.0.2"
67 71
68VDR_RC_DIR="/usr/lib/vdr/rcscript" 72# this is a hack for ebuilds like vdr-xineliboutput that want to
73# conditionally install a vdr-plugin
74if [[ "${GENTOO_VDR_CONDITIONAL:-no}" = "yes" ]]; then
75 # make DEPEND conditional
76 IUSE="${IUSE} vdr"
77 DEPEND="vdr? ( ${DEPEND} )"
78 RDEPEND="vdr? ( ${RDEPEND} )"
79fi
69 80
70# Pathes to includes 81# New method of storing plugindb
71VDR_INCLUDE_DIR="/usr/include" 82# Called from src_install
72DVB_INCLUDE_DIR="/usr/include" 83# file maintained by normal portage-methods
73 84create_plugindb_file() {
74
75# this code is from linux-mod.eclass
76update_vdrplugindb() {
77 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/ 85 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
86 local DB_FILE="${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
87 insinto "${NEW_VDRPLUGINDB_DIR}"
78 88
79 if [[ ! -f ${VDRPLUGINDB_DIR}/vdrplugindb ]]; then 89# BUG: portage-2.1.4_rc9 will delete the EBUILD= line, so we cannot use this code.
80 [[ ! -d ${VDRPLUGINDB_DIR} ]] && mkdir -p ${VDRPLUGINDB_DIR} 90# cat <<-EOT > "${D}/${DB_FILE}"
81 touch ${VDRPLUGINDB_DIR}/vdrplugindb 91# VDRPLUGIN_DB=1
92# CREATOR=ECLASS
93# EBUILD=${CATEGORY}/${PN}
94# EBUILD_V=${PVR}
95# EOT
96 {
97 echo "VDRPLUGIN_DB=1"
98 echo "CREATOR=ECLASS"
99 echo "EBUILD=${CATEGORY}/${PN}"
100 echo "EBUILD_V=${PVR}"
101 echo "PLUGINS=\"$@\""
102 } > "${D}/${DB_FILE}"
103}
104
105# Delete files created outside of vdr-plugin.eclass
106# vdrplugin-rebuild.ebuild converted plugindb and files are
107# not deleted by portage itself - should only be needed as
108# long as not every system has switched over to
109# vdrplugin-rebuild-0.2 / gentoo-vdr-scripts-0.4.2
110delete_orphan_plugindb_file() {
111 #elog Testing for orphaned plugindb file
112 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
113 local DB_FILE="${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
114
115 # file exists
116 [[ -f ${DB_FILE} ]] || return
117
118 # will portage handle the file itself
119 if grep -q CREATOR=ECLASS "${DB_FILE}"; then
120 #elog file owned by eclass - don't touch it
121 return
122 fi
123
124 elog "Removing orphaned plugindb-file."
125 elog "\t#rm ${DB_FILE}"
126 rm "${DB_FILE}"
127}
128
129
130create_header_checksum_file()
131{
132 # Danger: Not using $ROOT here, as compile will also not use it !!!
133 # If vdr in $ROOT and / differ, plugins will not run anyway
134
135 local CHKSUM="header-md5-vdr"
136
137 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then
138 cp "${VDR_CHECKSUM_DIR}/header-md5-vdr" "${CHKSUM}"
139 elif type -p md5sum >/dev/null 2>&1; then
140 (
141 cd "${VDR_INCLUDE_DIR}"
142 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
143 ) > "${CHKSUM}"
144 else
145 die "Could not create md5 checksum of headers"
146 fi
147
148 insinto "${VDR_CHECKSUM_DIR}"
149 local p_name
150 for p_name; do
151 newins "${CHKSUM}" "header-md5-${p_name}"
152 done
153}
154
155fix_vdr_libsi_include()
156{
157 #einfo "Fixing include of libsi-headers"
158 local f
159 for f; do
160 sed -i "${f}" \
161 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
162 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
163 done
164}
165
166vdr_patchmakefile() {
167 einfo "Patching Makefile"
168 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
169 cp Makefile "${WORKDIR}"/Makefile.before
170
171 # plugin makefiles use VDRDIR in strange ways
172 # assumptions:
173 # 1. $(VDRDIR) contains Make.config
174 # 2. $(VDRDIR) contains config.h
175 # 3. $(VDRDIR)/include/vdr contains the headers
176 # 4. $(VDRDIR) contains main vdr Makefile
177 # 5. $(VDRDIR)/locale exists
178 # 6. $(VDRDIR) allows to access vdr source files
179 #
180 # We only have one directory (for now /usr/include/vdr),
181 # that contains vdr-headers and Make.config.
182 # To satisfy 1-3 we do this:
183 # Set VDRDIR=/usr/include/vdr
184 # Set VDRINCDIR=/usr/include
185 # Change $(VDRDIR)/include to $(VDRINCDIR)
186
187 sed -i Makefile \
188 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
189 -e "/^VDRDIR/a VDRINCDIR = ${VDR_INCLUDE_DIR%/vdr}" \
190 -e '/VDRINCDIR.*=/!s:$(VDRDIR)/include:$(VDRINCDIR):' \
191 \
192 -e 's:-I$(DVBDIR)/include::' \
193 -e 's:-I$(DVBDIR)::'
194
195 # maybe needed for multiproto:
196 #sed -i Makefile \
197 # -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
198 # -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
199
200 if ! grep -q APIVERSION Makefile; then
201 ebegin " Converting to APIVERSION"
202 sed -i Makefile \
203 -e 's:^APIVERSION = :APIVERSION ?= :' \
204 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
205 -e '/VDRVERSION =/a\APIVERSION = $(shell sed -ne '"'"'/define APIVERSION/s/^.*"\\(.*\\)".*$$/\\1/p'"'"' $(VDRDIR)/config.h)'
206 eend $?
207 fi
208
209 # Correcting Compile-Flags
210 # Do not overwrite CXXFLAGS, add LDFLAGS if missing
211 sed -i Makefile \
212 -e '/^CXXFLAGS[[:space:]]*=/s/=/?=/' \
213 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
214
215 # Disabling file stripping, useful for debugging
216 sed -i Makefile \
217 -e '/@.*strip/d' \
218 -e '/strip \$(LIBDIR)\/\$@/d' \
219 -e 's/STRIP.*=.*$/STRIP = true/'
220
221 # Use a file instead of a variable as single-stepping via ebuild
222 # destroys environment.
223 touch "${WORKDIR}"/.vdr-plugin_makefile_patched
224}
225
226vdr_has_gettext() {
227 has_version ">=media-video/vdr-1.5.7"
228}
229
230plugin_has_gettext() {
231 [[ -d po ]]
232}
233
234vdr_i18n_convert_to_gettext() {
235 if has_version ">=media-video/vdr-1.7.22"; then
236 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext"
237 else
238 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext.pl"
239 fi
240
241 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
242 ewarn "Conversion to gettext disabled in ebuild"
243 return 1
244 fi
245
246 if [[ ! -x ${i18n_tool} ]]; then
247 eerror "Missing ${i18n_tool}"
248 eerror "Please re-emerge vdr"
249 die "Missing ${i18n_tool}"
250 fi
251
252 ebegin "Auto converting translations to gettext"
253 # call i18n-to-gettext tool
254 # take all texts missing tr call into special file
255 "${i18n_tool}" 2>/dev/null \
256 |sed -e '/^"/!d' \
257 -e '/^""$/d' \
258 -e 's/\(.*\)/trNOOP(\1)/' \
259 > dummy-translations-trNOOP.c
260
261 # if there were untranslated texts just run it again
262 # now the missing calls are listed in
263 # dummy-translations-trNOOP.c
264 if [[ -s dummy-translations-trNOOP.c ]]; then
265 "${i18n_tool}" &>/dev/null
266 fi
267
268 # now use the modified Makefile
269 if [[ -f Makefile.new ]]; then
270 mv Makefile.new Makefile
271 eend 0 ""
272 else
273 eend 1 "Conversion to gettext failed. Plugin needs fixing."
274 return 1
275 fi
276}
277
278vdr_i18n_disable_gettext() {
279 #einfo "Disabling gettext support in plugin"
280
281 # Remove i18n Target if using older vdr
282 sed -i Makefile \
283 -e '/^all:/s/ i18n//'
284}
285
286vdr_i18n() {
287 if vdr_has_gettext; then
288 #einfo "VDR has gettext support"
289 if plugin_has_gettext; then
290 #einfo "Plugin has gettext support, fine"
291 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
292 ewarn "Please remove unneeded NO_GETTEXT_HACK from ebuild."
293 fi
294 else
295 vdr_i18n_convert_to_gettext
296 if [[ $? != 0 ]]; then
297 einfo "Plugin has no OSD texts or will have only english OSD texts"
298 fi
82 fi 299 fi
83 if [[ -z $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then 300 else
84 einfo "Adding plugin to vdrplugindb." 301 #einfo "VDR has no gettext support"
85 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${VDRPLUGINDB_DIR}/vdrplugindb 302 if plugin_has_gettext; then
303 vdr_i18n_disable_gettext
86 fi 304 fi
87}
88
89remove_vdrplugindb() {
90 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/
91
92 if [[ -n $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
93 einfo "Removing ${CATEGORY}/${PN}-${PVR} from vdrplugindb."
94 sed -ie "/.*${CATEGORY}\/${P}.*/d" ${VDRPLUGINDB_DIR}/vdrplugindb
95 fi 305 fi
96} 306}
307
308vdr-plugin_copy_source_tree() {
309 pushd . >/dev/null
310 cp -r "${S}" "${T}"/source-tree
311 cd "${T}"/source-tree
312 cp "${WORKDIR}"/Makefile.before Makefile
313 # TODO: Fix this, maybe no longer needed
314 sed -i Makefile \
315 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
316 -e 's:^CXXFLAGS:#CXXFLAGS:' \
317 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
318 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
319 popd >/dev/null
320}
321
322vdr-plugin_install_source_tree() {
323 einfo "Installing sources"
324 destdir="${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}"
325 insinto "${destdir}-${PV}"
326 doins -r "${T}"/source-tree/*
327
328 dosym "${VDRPLUGIN}-${PV}" "${destdir}"
329}
330
331vdr-plugin_print_enable_command() {
332 local p_name c=0 l=""
333 for p_name in ${vdr_plugin_list}; do
334 c=$(( c+1 ))
335 l="$l ${p_name#vdr-}"
336 done
337
338 elog
339 case $c in
340 1) elog "Installed plugin${l}" ;;
341 *) elog "Installed $c plugins:${l}" ;;
342 esac
343 elog "To activate a plugin execute this command:"
344 elog "\teselect vdr-plugin enable <plugin_name> ..."
345 elog
346}
347
348has_vdr() {
349 [[ -f "${VDR_INCLUDE_DIR}"/config.h ]]
350}
351
352## exported functions
97 353
98vdr-plugin_pkg_setup() { 354vdr-plugin_pkg_setup() {
99 # -fPIC is needed for shared objects on some platforms (amd64 and others) 355 # -fPIC is needed for shared objects on some platforms (amd64 and others)
100 append-flags -fPIC 356 append-flags -fPIC
101 357
102 VDRVERSION=$(awk -F'"' '/VDRVERSION/ {print $2}' /usr/include/vdr/config.h) 358 # Plugins need to be compiled with position independent code, otherwise linking
103 einfo "Building ${PF} against vdr-${VDRVERSION}" 359 # VDR against it will fail
104} 360 if has_version ">=media-video/vdr-1.7.13"; then
361 append-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
362 fi
105 363
364 # Where should the plugins live in the filesystem
365 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins"
366 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums"
367
368 # was /usr/lib/... some time ago
369 # since gentoo-vdr-scripts-0.3.6 it works with /usr/share/...
370 VDR_RC_DIR="/usr/share/vdr/rcscript"
371
372 # Pathes to includes
373 VDR_INCLUDE_DIR="/usr/include/vdr"
374 DVB_INCLUDE_DIR="/usr/include"
375
376 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale"
377 if has_version ">=media-video/vdr-1.6.0_p2-r7"; then
378 LOCDIR="/usr/share/locale"
379 else
380 LOCDIR="/usr/share/vdr/locale"
381 fi
382
383 if ! has_vdr; then
384 # set to invalid values to detect abuses
385 VDRVERSION="eclass_no_vdr_installed"
386 APIVERSION="eclass_no_vdr_installed"
387
388 if [[ "${GENTOO_VDR_CONDITIONAL:-no}" = "yes" ]] && ! use vdr; then
389 einfo "VDR not found!"
390 else
391 # if vdr is required
392 die "VDR not found!"
393 fi
394 return
395 fi
396
397 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
398 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
399 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
400
401 einfo "Compiling against"
402 einfo "\tvdr-${VDRVERSION} [API version ${APIVERSION}]"
403
404
405 if [ -n "${VDR_LOCAL_PATCHES_DIR}" ]; then
406 eerror "Using VDR_LOCAL_PATCHES_DIR is deprecated!"
407 eerror "Please move all your patches into"
408 eerror "${EROOT}/etc/portage/patches/${CATEGORY}/${P}"
409 eerror "and remove or unset the VDR_LOCAL_PATCHES_DIR variable."
410 die
411 fi
412}
413
106vdr-plugin_src_unpack() { 414vdr-plugin_src_util() {
107 [ -z "$1" ] && vdr-plugin_src_unpack unpack patchmakefile
108
109 while [ "$1" ]; do 415 while [ "$1" ]; do
110
111 case "$1" in 416 case "$1" in
417 all)
418 vdr-plugin_src_util unpack add_local_patch patchmakefile i18n
419 ;;
420 prepare|all_but_unpack)
421 vdr-plugin_src_util add_local_patch patchmakefile i18n
422 ;;
112 unpack) 423 unpack)
113 unpack ${A} 424 base_src_unpack
425 ;;
426 add_local_patch)
427 cd "${S}" || die "Could not change to plugin-source-directory!"
428 epatch_user
114 ;; 429 ;;
115 patchmakefile) 430 patchmakefile)
116 cd ${S} 431 cd "${S}" || die "Could not change to plugin-source-directory!"
117 432 vdr_patchmakefile
118 ebegin "Patching Makefile" 433 ;;
119 sed -i Makefile \ 434 i18n)
120 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \ 435 cd "${S}" || die "Could not change to plugin-source-directory!"
121 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \ 436 vdr_i18n
122 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \
123 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \
124 -e 's:^CXXFLAGS:#CXXFLAGS:' \
125 -e 's:-I$(VDRDIR)/include:-I$(VDRDIR):' \
126 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
127 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):' \
128 -e 's:$(VDRDIR)/\(config.h\|Make.config\):$(VDRDIR)/vdr/\1:'
129 eend $?
130 ;; 437 ;;
131 esac 438 esac
132 439
133 shift 440 shift
134 done 441 done
135} 442}
136 443
444vdr-plugin_src_unpack() {
445 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
446 eerror "Wrong use of vdr-plugin.eclass."
447 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
448 echo
449 eerror "Please report this at bugs.gentoo.org."
450 die "vdr-plugin_pkg_setup not called!"
451 fi
452 if [ -z "$1" ]; then
453 case "${EAPI:-0}" in
454 2|3|4)
455 vdr-plugin_src_util unpack
456 ;;
457 *)
458 vdr-plugin_src_util all
459 ;;
460 esac
461
462 else
463 vdr-plugin_src_util $@
464 fi
465}
466
467vdr-plugin_src_prepare() {
468 base_src_prepare
469 vdr-plugin_src_util prepare
470}
471
137vdr-plugin_src_compile() { 472vdr-plugin_src_compile() {
473 [ -z "$1" ] && vdr-plugin_src_compile copy_source compile
474
475 while [ "$1" ]; do
476
477 case "$1" in
478 copy_source)
479 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
480 ;;
481 compile)
482 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then
483 eerror "Wrong use of vdr-plugin.eclass."
484 eerror "An ebuild for a vdr-plugin will not work without"
485 eerror "calling vdr-plugin_src_unpack to patch the Makefile."
486 echo
487 eerror "Please report this at bugs.gentoo.org."
488 die "vdr-plugin_src_unpack not called!"
489 fi
138 cd ${S} 490 cd "${S}"
139 491
140 emake ${VDRPLUGIN_MAKE_TARGET:-all} || die "emake failed" 492 BUILD_TARGETS=${BUILD_TARGETS:-${VDRPLUGIN_MAKE_TARGET:-all}}
493
494 emake ${BUILD_PARAMS} \
495 ${BUILD_TARGETS} \
496 LOCALEDIR="${TMP_LOCALE_DIR}" \
497 LIBDIR="${S}" \
498 TMPDIR="${T}" \
499 || die "emake failed"
500 ;;
501 esac
502
503 shift
504 done
141} 505}
142 506
143vdr-plugin_src_install() { 507vdr-plugin_src_install() {
508 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree
509 cd "${WORKDIR}"
510
511 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then
512 local mname="${P}-Makefile"
513 cp "${S}"/Makefile "${mname}.patched"
514 cp Makefile.before "${mname}.before"
515
516 diff -u "${mname}.before" "${mname}.patched" > "${mname}.diff"
517
518 insinto "/usr/share/vdr/maintainer-data/makefile-changes"
519 doins "${mname}.diff"
520
521 insinto "/usr/share/vdr/maintainer-data/makefile-before"
522 doins "${mname}.before"
523
524 insinto "/usr/share/vdr/maintainer-data/makefile-patched"
525 doins "${mname}.patched"
526
527 fi
528
529
530
144 cd ${S} 531 cd "${S}"
145
146 insinto "${VDR_PLUGIN_DIR}" 532 insinto "${VDR_PLUGIN_DIR}"
147 doins libvdr-*.so.* 533 doins libvdr-*.so.*
148 dodoc README* HISTORY CHANGELOG
149 534
150 for f in ${FILESDIR}/confd-${PV} ${FILESDIR}/confd; do 535 # create list of all created plugin libs
151 if [[ -f "${f}" ]]; then 536 vdr_plugin_list=""
152 insinto /etc/conf.d 537 local p_name
153 newins "${f}" vdr.${VDRPLUGIN} 538 for p in libvdr-*.so.*; do
154 break 539 p_name="${p%.so*}"
155 fi 540 p_name="${p_name#lib}"
541 vdr_plugin_list="${vdr_plugin_list} ${p_name}"
156 done 542 done
157 543
158 for f in ${FILESDIR}/rc-addon-${PV}.sh ${FILESDIR}/rc-addon.sh; do 544 create_header_checksum_file ${vdr_plugin_list}
159 if [[ -f "${f}" ]]; then 545 create_plugindb_file ${vdr_plugin_list}
546
547 if vdr_has_gettext && [[ -d ${TMP_LOCALE_DIR} ]]; then
548 einfo "Installing locales"
549 cd "${TMP_LOCALE_DIR}"
160 insinto "${VDR_RC_DIR}" 550 insinto "${LOCDIR}"
161 newins "${f}" vdr.${VDRPLUGIN}.sh 551 doins -r *
162 break
163 fi 552 fi
553
554 cd "${S}"
555 local docfile
556 for docfile in README* HISTORY CHANGELOG; do
557 [[ -f ${docfile} ]] && dodoc ${docfile}
164 done 558 done
559
560 # if VDR_CONFD_FILE is empty and ${FILESDIR}/confd exists take it
561 [[ -z ${VDR_CONFD_FILE} ]] && [[ -e ${FILESDIR}/confd ]] && VDR_CONFD_FILE=${FILESDIR}/confd
562
563 if [[ -n ${VDR_CONFD_FILE} ]]; then
564 newconfd "${VDR_CONFD_FILE}" vdr.${VDRPLUGIN}
565 fi
566
567
568 # if VDR_RCADDON_FILE is empty and ${FILESDIR}/rc-addon.sh exists take it
569 [[ -z ${VDR_RCADDON_FILE} ]] && [[ -e ${FILESDIR}/rc-addon.sh ]] && VDR_RCADDON_FILE=${FILESDIR}/rc-addon.sh
570
571 if [[ -n ${VDR_RCADDON_FILE} ]]; then
572 insinto "${VDR_RC_DIR}"
573 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh
574 fi
165} 575}
166 576
167vdr-plugin_pkg_postinst() { 577vdr-plugin_pkg_postinst() {
168 update_vdrplugindb 578 vdr-plugin_print_enable_command
169 einfo 579
170 einfo "The vdr plugin ${VDRPLUGIN} has now been installed," 580 if [[ -n "${VDR_CONFD_FILE}" ]]; then
171 einfo "to activate it you have to add it to /etc/conf.d/vdr." 581 elog "Please have a look at the config-file"
172 einfo 582 elog "\t/etc/conf.d/vdr.${VDRPLUGIN}"
583 elog
584 fi
173} 585}
174 586
175vdr-plugin_pkg_postrm() { 587vdr-plugin_pkg_postrm() {
176 remove_vdrplugindb 588 delete_orphan_plugindb_file
177} 589}
178 590
591vdr-plugin_pkg_config() {
592:
593}
594
595case "${EAPI:-0}" in
596 2|3|4)
597 EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_compile src_install pkg_postinst pkg_postrm pkg_config
598 ;;
599 *)
179EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm 600 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config
601 ;;
602esac

Legend:
Removed from v.1.3  
changed lines
  Added in v.1.84

  ViewVC Help
Powered by ViewVC 1.1.20